--星魂试炼 查看章节Panel
Lua_StarTrialChapterPanel = class("Lua_StarTrialChapterPanel", Lua_DisplayObject);
function Lua_StarTrialChapterPanel:ctor(go)
	self:superCall("ctor", go);
end

function Lua_StarTrialChapterPanel:buildPanel(go)
	self:superCall("buildPanel", go);
	self:addLuaEvent("UPDATE_STARTRIAL_CHAPTER_INFO", self, self.updateData);
end

function Lua_StarTrialChapterPanel:buildShowItem()
	self:superCall("buildShowItem");
    
    self.maskBg = UICreate.createImage(self.content, "/images/starTrial/xui_xhd_bj_003.png", 0, 0, 0, 0);
    self.maskBg.anchor = Lua_WindowUtil.getAnchor(1);
    self.maskBg.pivotValue = 1;
    self.maskBg:setLocation(0, 360 - self.adaptHeight);

	self.dragContainer = Lua_DragContainer.new(self.content, 700, 700 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.dragContainer:setLocation(20, 250);
	self.dragContainer:setCellSpacing(0, 10);
	self.dragContainer:setSiblingIndex(0);

	Lua_ProxyManager.getProxy("Lua_StarTrialProxy"):sChapterInfo();
end

function Lua_StarTrialChapterPanel:updateData()
	local curChapter = DataCenter.starTrialData.curChapter;
	local totalArr = DataCenter.starTrialUitl.getChapterArr;
	for i = 1, totalArr:getSize() do
		if i <= curChapter then
			if i == 1 or totalArr[i - 1].starNum >= totalArr[i].unlock_star then
				if DataCenter.roleData.level >= totalArr[i].limit_lvl then
					totalArr[i].state = 1;
				end
			end
		end
	end
	self.dragContainer:clearList();
	local index = 0;
	for i = 1, totalArr:getSize() do
		if index == 0 and totalArr[i].canDraw == true then
			index = i;
		end
		self.dragContainer:addSubContainer(Lua_StarTrialChapterViewItem, totalArr[i], false);
	end
	self.dragContainer:updateChildPos();
	self.dragContainer:moveToIndex(index);
end

function Lua_StarTrialChapterPanel:onScreenResize(adaptHeight)
    self:superCall("onScreenResize", adaptHeight);
    self.dragContainer:setContentRect(700, 700 + adaptHeight);
    self.maskBg:setLocation(0, 360 - adaptHeight);
end

function Lua_StarTrialChapterPanel:dispose()
	if self.dragContainer ~= nil then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end
	self:superCall("dispose");
end










Lua_StarTrialChapterViewItem = class("Lua_StarTrialChapterViewItem", Lua_DragContainerItem);
function Lua_StarTrialChapterViewItem:ctor(p)
	self:superCall("ctor", p, "StarTrialChapterViewItem_skin");
end

function Lua_StarTrialChapterViewItem:buildShowItem()
	self:superCall("buildShowItem");
    
    self.chapterNum = Lua_NumberImage.new(self.content);
    self.chapterNum.pivot = 0;
    self.chapterNum.numAtlas = "number";
    self.chapterNum.preStr = "xui_xhd_number_";
    self.chapterNum.numOffsetX = -20;
    self.tipTxt.pivot = Lua_WindowUtil.getPivot(5);
	self.boxIcon:addClickFuntion(self, self.onChapterInfoClick);
end

function Lua_StarTrialChapterViewItem:onPressClick()
	self:superCall("onPressClick");
	self:onChapterClick();
end

function Lua_StarTrialChapterViewItem:setData(data)
	self.data = data;

	if self.data.id == DataCenter.starTrialUitl.getChapterArr:getSize() then
		self.offsetY = 60;
	else
		self.offsetY = 0;
	end
	
	local chapternum = tonumber(data.id);
    self.chapterNum.num = chapternum;
    if chapternum > 0 and chapternum < 10 then
    	self.chapterNum:setLocation(-200, -3 + self.offsetY);
    	self.chapterIconTwo:setLocation(-162, -1 + self.offsetY)
    elseif chapternum >= 10 and chapternum < 100 then
    	self.chapterNum:setLocation(-190, -3 + self.offsetY);
    	self.chapterIconTwo:setLocation(-145, -1 + self.offsetY)
    else
    	self.chapterNum:setLocation(-176, -3 + self.offsetY);
    	self.chapterIconTwo:setLocation(-120, -1 + self.offsetY)
    end

	self.starNumTxt.text = data.starNum .. "/" .. data.total_star;
	if data.isMaxStar then
		self.collectSignIcon:setEnable(true);
	else
		self.collectSignIcon:setEnable(false);
	end
	self.progressBar:setMaxValue(data.total_star);
	self.progressBar:setValue(data.starNum);
	self.progressBar:setEnable(not data.isMaxStar);
	self.limitObj:SetActive(data.state == 0);
	self.bg:setGray(data.state == 0);
	self.boxIcon:setGray(data.state == 0);
	self.tipTxt:setEnable(data.state == 0);
	self.starObj:SetActive(data.state ~= 0);

	if data.state == 0 then
		local prevVo = DataCenter.starTrialUitl:getChapterVo(data.prev_chapter);
		local str = spliceIconStr("starTrial_altas", "xui_xhd_label_002", 31, 30);
		self.tipTxt.text = LanUtil.formateStr(201619, tostring(data.limit_lvl), prevVo.remark, tostring(data.unlock_star), str);
		self.tipTxt:resetSize();
		self.tipTxt:setLocation(283, -28);
		
		self.starNumBg:SetDimensions(228, 65);
		self.starNumBg:setLocation(178, -32 + self.offsetY);

		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	else
		self.starNumBg:SetDimensions(228, 52);
		self.starNumBg:setLocation(178, -37 + self.offsetY);

		if data.canDraw == true then
			if self.redPoint == nil then
				self.redPoint = Lua_RedPointIcon.new(self.content);
				self.redPoint:createRedPointEff();
				self.redPoint:setLocation(290, 60);
			end
			self.redPoint:updateRedPointShow(true);
		else
			if self.redPoint ~= nil then
				self.redPoint:updateRedPointShow(false);
			end
		end
	end

	self.bg:setLocation(0, 0 + self.offsetY);
	self.boxIcon:setLocation(193, 10 + self.offsetY);
	self.starNumBg:setLocation(178, -32 + self.offsetY);
	self.chapterIconOne:setLocation(-238, -1 + self.offsetY);
	LuaUtil.setObjPos(self.starObj, 0, 4 + self.offsetY, 0);
	LuaUtil.setObjPos(self.limitObj, 0, 4 + self.offsetY, 0);
end

function Lua_StarTrialChapterViewItem:onChapterClick()
	if self.data.state == 0 then
		OperateAlert.showLangValue(201605);
		return;
	end
	Lua_MsgUtil.callFunc("UPDATE_STARTRIAL_CHAPTER_SELECT", {chapter = self.data.id});
end

function Lua_StarTrialChapterViewItem:onChapterInfoClick()
	if self.data.state == 0 then
		OperateAlert.showLangValue(201605);
		return;
	end
	local vo = DataCenter.starTrialUitl:getChapterVo(self.data.id);
	Lua_WindowUtil.openWin("Lua_StarTrialStarRewardWindow", Lua_WinParam.ACTION_OPEN, self.data.id);
end

function Lua_StarTrialChapterViewItem:getWidth()
	return self.bg.width;
end

function Lua_StarTrialChapterViewItem:getHeight()
	if self.data.id == DataCenter.starTrialUitl.getChapterArr:getSize() then
		return self.bg.height + 120;
	else
		return self.bg.height;
	end
end

function Lua_StarTrialChapterViewItem:dispose()
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	if self.chapterNum ~= nil then
		self.chapterNum:dispose();
		self.chapterNum = nil;
	end
	self:superCall("dispose");
end