--星河殿，扫荡补星Window
Lua_StarTrialDailyRewardWindow = class("Lua_StarTrialDailyRewardWindow", Lua_Window);

function Lua_StarTrialDailyRewardWindow:ctor()
	self:superCall("ctor");

	self.showBlackMask = true;
	self.isClickClose = true;
	self.skinName = "StarTrialDailyRewardWindow_skin";
	self.windowName = "Lua_StarTrialDailyRewardWindow";
end

function Lua_StarTrialDailyRewardWindow:buildShowItem()
	self:superCall("buildShowItem");

    self.buttonItemInfoArr = Array();
    self.buttonItemInfoArr:add({des = LanUtil.getValue(201626), type = 1});
    self.buttonItemInfoArr:add({des = LanUtil.getValue(201627), type = 2});

    self.buttonList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
    self.buttonList:setLocation(13, -446);
    self.buttonList:setButtonItem(191, 58);
    self.buttonList:setButtonCell(Lua_StarTrialDailyButtonItem);
    self.buttonList:setClickCallBack(self, self.onButtonListClick);
    self.buttonList:setData(self.buttonItemInfoArr);

    self.showStateList = {};--记录章节是处于展开还是收起状态
    self.isInitChapterList = false; --是否已经切换到补星过
        
    self:addLuaEvent("UPDATE_CHAPTER_SHOW", self, self.updateChapterList);
    self:addLuaEvent("UPDATE_STARTRIAL_DAILYREWARD", self, self.updateSweepInfo);
    self:addLuaEvent("INIT_NOMAXCHAPTER_DATA", self, self.showWinInfo);

    Lua_ProxyManager.getProxy("Lua_StarTrialProxy"):sNoMaxStarChapterInfo();
end

function Lua_StarTrialDailyRewardWindow:showWinInfo(chapterList)
	if chapterList == nil then
		return;
	end
	self.chapterList = chapterList;
	self.buttonList:setSelected(1);
end

function Lua_StarTrialDailyRewardWindow:onButtonListClick(type)
	if type == 1 then
		self:updateSweepInfo();
	elseif type == 2 then
		self:showChapterList();
	end
end

function Lua_StarTrialDailyRewardWindow:showChapterList()
	self.sweepItem:setEnable(false);
	if self.isInitChapterList then
		self.dragContainer:setEnable(true);
	else
		if self.dragContainer == nil then
			self.dragContainer = Lua_DragContainer.new(self.content, 710, 604, Lua_AxisDefine.Vertical);
		    self.dragContainer:setCellPivot(1);
			self.dragContainer:setLocation(4, -71, 0);
		end
		self:updateChapterList();
		self.isInitChapterList = true;
	end
end

function Lua_StarTrialDailyRewardWindow:updateSweepInfo()
	if self.sweepItem == nil then
		self.sweepItem = Lua_StarTrialDailyRewardItem.new(self.content);
		self.sweepItem:setLocation(0, 148);
	end
	local sweepId = DataCenter.starTrialData.curSweepId;
	local info = DataCenter.starTrialUitl:getSweepInfoById(sweepId);
	self.sweepItem:setEnable(true);
	self.sweepItem:setData(info.reward);
	if self.dragContainer ~= nil then
		self.dragContainer:setEnable(false);
	end

	self.tipsTxt:setLangValue(201624);
end

function Lua_StarTrialDailyRewardWindow:updateChapterList(data)
	local list = self.chapterList;
	local chapter;
	if data ~= nil then
		for i = 1, #list do
			chapter = list[i].chapter
			if chapter == data.chapter then
				self.showStateList[chapter] = data.showState;
			else
				self.showStateList[chapter] = false;
			end
		end
	else
		for i = 1, #list do
			chapter = list[i].chapter;
			self.showStateList[chapter] = false;
		end
	end
	self:updateChapterDrag();
end

function Lua_StarTrialDailyRewardWindow:updateChapterDrag()
	self.dragContainer:clearList();
	local list = self.chapterList;
	local chapter;
	local data;
	for i = 1, #list do
		chapter = list[i].chapter;
		data = {chapterData = list[i], showState = self.showStateList[chapter]}
		self.dragContainer:addSubContainer(Lua_StarTrialChapterItem, data, false);
	end
	self.dragContainer:updateChildPos();

	if self.subRectH == nil then
		self.subRectH = self.dragContainer.subRectH;
	end
	local offsetH = self.dragContainer.subRectH - self.subRectH;
	local subPos = self.dragContainer.curSubPos - offsetH / 2;
	if subPos < self.dragContainer.subMinPos then
		subPos = self.dragContainer.subMinPos;
	elseif subPos > self.dragContainer.subMaxPox then
		subPos = self.dragContainer.subMaxPox;
	end
    self.dragContainer:setSubPosition(subPos);
	self.subRectH = self.dragContainer.subRectH;

	self.tipsTxt:setLangValue(201625);
end

function Lua_StarTrialDailyRewardWindow:dispose()
	if self.dragContainer ~= nil then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end
    if self.buttonItemInfoArr ~= nil then
    	self.buttonItemInfoArr:dispose();
    	self.buttonItemInfoArr:clear();
    	self.buttonItemInfoArr = nil;
    end
    if self.buttonList ~= nil then
    	self.buttonList:dispose();
    	self.buttonList = nil;
    end
    if self.sweepItem ~= nil then
    	self.sweepItem:dispose();
    	self.sweepItem = nil;
    end
    self.chapterList = nil;
    self.showStateList = nil;
	self:superCall("dispose");
end


























Lua_StarTrialDailyRewardItem = class("Lua_StarTrialDailyRewardItem", Lua_DisplayObject);

function Lua_StarTrialDailyRewardItem:ctor(p)
	self:superCall("ctor", p, "StarTrialDailyRewardItem_skin");
end

function Lua_StarTrialDailyRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_ItemIconList.new(self.content);
	self.rewardList:setLocation(-245, -16, 0);
	self.rewardList.scaleVal = 0.8;
	self.rewardList.pivot = 1;
	self.rewardList.canClick = true;

	self.sweepOneBtn:addClickFuntion(self, self.onSweepBtnClick);
end

function Lua_StarTrialDailyRewardItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self:superCall("dispose");
end

function Lua_StarTrialDailyRewardItem:setData(data)
	self.daySweepTimes.text = LanUtil.formateStr(201621, DataCenter.starTrialData.sweepTimes);
	if tonumber(DataCenter.starTrialData.sweepTimes) > 0 then
		self.sweepOneBtn:setStyle(1);
	else
		self.sweepOneBtn:setStyle(16);
		self.sweepOneBtn:removeClickFuntion(self, self.onSweepBtnClick)
	end

	self.rewardList:setArrayData(data);
end

function Lua_StarTrialDailyRewardItem:onSweepBtnClick()
	Lua_ProxyManager.getProxy("Lua_StarTrialProxy"):sGetDailyReward();
end








Lua_StarTrialChapterItem = class("Lua_StarTrialChapterItem", Lua_DragContainerItem);
function Lua_StarTrialChapterItem:ctor(p)
	self:superCall("ctor", p, "StarTrialChapterItem_skin");
end

function Lua_StarTrialChapterItem:buildShowItem()
	self:superCall("buildShowItem");
    
	self.showLevelCount = 0;
	self.levelArr = Array();
	self.showSign:addClickFuntion(self, self.showSignClick);
end

function Lua_StarTrialChapterItem:setData(data)
	if data == nil then
		return;
	end
	self.data = data;

	local chapterVo = DataCenter.starTrialUitl:getChapterVo(data.chapterData.chapter);
	if chapterVo == nil then
		return;
	end

	self.chapterName.text = chapterVo.remark;
	self.starNum.text = chapterVo.starNum.."/"..chapterVo.total_star;

	if data.showState == true then
		self.showSign:setRot(0, 0, 0);
		
		local index = 0;
		local arrLen = self.levelArr:getSize();
		local dataLen = #data.chapterData.stage_star;
		local maxLen = dataLen > arrLen and dataLen or arrLen;
		local item;
		local stageList = data.chapterData.stage_star;
		self.showLevelCount = dataLen;
		table.sort(stageList, function(a, b) return a.type < b.type; end);

		for i = 1, maxLen do
			item = self.levelArr[i];
			if i > dataLen then
				if item ~= nil then
					item:setEnable(false);
				end
			else
				if item == nil then
					item = Lua_StarTrialLevelItem.new(self.content);
					item:setRectAnchor(1);
					self.levelArr:add(item);
			    end
			    index = index + 1;
			    item:setEnable(true);
			    item:setData(stageList[i]);
			    item:setLocation(0, -self.bg.height - item.bg.height / 2 - (index - 1) * 90);
			end
		end
	else
		self.showSign:setRot(0, 0, 180);
		self.showLevelCount = 0;

		for i = 1, self.levelArr:getSize() do
			self.levelArr[i]:setEnable(false);
	    end 
	end
end

function Lua_StarTrialChapterItem:showSignClick()
	local data = {chapter = self.data.chapterData.chapter, showState = not self.data.showState}
	Lua_MsgUtil.callFunc("UPDATE_CHAPTER_SHOW", data);
end

function Lua_StarTrialChapterItem:getWidth()
	return 700;
end

function Lua_StarTrialChapterItem:getHeight()
	return 83 + self.showLevelCount * 90;
end

function Lua_StarTrialChapterItem:dispose()
	if self.levelArr ~= nil then
		self.levelArr:dispose();
		self.levelArr:clear();
		self.levelArr = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end





Lua_StarTrialLevelItem = class("Lua_StarTrialLevelItem", Lua_ListCell);
function Lua_StarTrialLevelItem:ctor(p)
	self:superCall("ctor", p, "StarTrialLevelItem_skin");
end

function Lua_StarTrialLevelItem:buildShowItem()
	self:superCall("buildShowItem");

	self.starList = {self.starOne, self.starTwo, self.starThree};
	self.goBtn:addClickFuntion(self, self.onGoBtnClick);
end

function Lua_StarTrialLevelItem:setData(data)
	if data == nil then
		return;
	end

	self._data = data;
	self.stageVo = DataCenter.starTrialUitl:getStageVo(data.type);
	self.levelNumTxt.text = self.stageVo.chapter.."-"..self.stageVo.index;
	for i = 1, #data.map_list do
		if data.map_list[i].value == 0 then
			self.starList[i]:setAltas("starTrial_altas", "xui_xhd_label_010");
		else
			self.starList[i]:setAltas("starTrial_altas", "xui_xhd_label_002");
		end
	end
end

function Lua_StarTrialLevelItem:onGoBtnClick()
	local stageVo = DataCenter.starTrialUitl:getStageVo(self._data.type);
	Lua_MsgUtil.callFunc("UPDATE_STARTRIAL_CHAPTER_SELECT", {chapter = self.stageVo.chapter, level = self.stageVo.index});
	if Lua_WindowUtil.isWindowShowing("Lua_StarTrialDailyRewardWindow") then
		Lua_WindowUtil.openWin("Lua_StarTrialDailyRewardWindow", Lua_WinParam.ACTION_CLOSE);
	end
end

function Lua_StarTrialLevelItem:dispose()
	self.starList = nil;
	self.stageVo = nil;
	self._data = nil;
	self:superCall("dispose");
end







Lua_StarTrialDailyButtonItem = class("Lua_StarTrialDailyButtonItem", Lua_ButtonCell)
function Lua_StarTrialDailyButtonItem:ctor(p)
	self:superCall("ctor", p, "StarTrialDailyButtonItem_skin");
end

function Lua_StarTrialDailyButtonItem:buildShowItem()
	self:superCall("buildShowItem");
    
	self.bg:addClickFuntion(self, self.onPressClick);
end

function Lua_StarTrialDailyButtonItem:dispose()
	self:superCall("dispose");
end

function Lua_StarTrialDailyButtonItem:setData(data)
	self.data = data;
	self.titleTxt.text = data.des;
end

function Lua_StarTrialDailyButtonItem:setSelected(index)
	if index == self.index then
		self.bg:setAltas("common_altas_1", "xui_common_button_006_n");
		self.bg:SetDimensions(191, 58);
		self.bg:setLocation(0, 0);
		self.bg.alpha = 1;
		self.titleTxt.colorStr = Lua_ColorDefine.transColorStr("8F5123");
		self.titleTxt:setLocation(0, 0);
	else
		self.bg:setAltas("common_altas_1", "xui_common_button_007_n");
		self.bg:SetDimensions(160, 58);
		self.bg.alpha = 0.01;
		self.titleTxt.colorStr = Lua_ColorDefine.transColorStr("594D4D");
		if self.index > index then
			self.bg:setLocation(-16, 0);
			self.titleTxt:setLocation(-16, 0);
		else
			self.bg:setLocation(16, 0);
			self.titleTxt:setLocation(16, 0);
		end
	end
end