checkRequire("Lua_StarTrialStarItem");
checkRequire("Lua_StarTrialLevelInfoItem");
Lua_StarTrialLevelPanel = class("Lua_StarTrialLevelPanel", Lua_DisplayObject);
function Lua_StarTrialLevelPanel:ctor(go)
	self:superCall("ctor", go, "StarTrialLevelPanel_skin");
end

function Lua_StarTrialLevelPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.stageItemArr = Array();
	self.rewardBoxArr = Array();

	self.starBar.typeValue = 3;
	self.starBar.fillMethodValue = 1;
	self.starBar.fillOrigin = 0;

	self.maskBg = UICreate.createImage(self.content, "/images/starTrial/xui_xhd_bj_003.png", 0, 0, 0, 0);
    self.maskBg.anchor = Lua_WindowUtil.getAnchor(1);
    self.maskBg.pivotValue = 1;
    self.maskBg.siblingIndex = 1;
    self.maskBg:setLocation(0, 360 - self.adaptHeight);

	self.dragContainer = Lua_DragContainer.new(self.content, 720, 850 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.dragContainer:setLocation(0, 0);
	self.dragContainer:setRectAnchor(1);
	self.dragContainer:setRectPivot(1);
	self.dragContainer:setSiblingIndex(0);
	self.maskBg:setLocation(0, 360 - self.adaptHeight);

	if DataCenter.funcOpenData:isOpened(DataCenter.starRiverTrialData.config["const"].act_open_id) then
		self.trialBtn = UICreate.createUIAtlasImage(self.content, "starTrial_altas", "xui_xhd_button_008_n", 288, 406, 100, 106);
		self.trialBtn.anchor = Lua_WindowUtil.getAnchor(7);
		self.trialBtn.name = "trialBtn";
		self.trialBtn:addClickFuntion(self, self.onStarRiverTrialClick);

		self.trialRedPoint = Lua_RedPointIcon.new(self.content);
		self.trialRedPoint:setLocation(312, 434);
		self.trialRedPoint:setRectAnchor(7);
		self.trialRedPoint:createRedPointEff();
	end
    
    --是否自动切换至下一章节
	self.autoCutChapter = false;

	self.tipIocn:addClickFuntion(self, self.onTipIconClick);
	self.sweepBtn:addClickFuntion(self, self.onBoxIconClick);
	self.rankBtn:addClickFuntion(self, self.onRankBtnClick);
	self:addLuaEvent("UPDATE_STARTRIAL_INFO", self, self.updatePanel);
	self:addLuaEvent("UPDATE_STARTRIAL_STARREWARD", self, self.updateStarReward);
	self:addLuaEvent("UPDATE_STARTRIAL_DAILYREWARD", self, self.updateDailyReward);
	self:addLuaEvent("CLOSE_TRIALBTN", self, self.closeTrialBtn);
	self:addLuaEvent("STARTRIAL_SELECT_LEVEL", self, self.buildLevelInfo);
	self:addLuaEvent("UPDATE_STARRIVER_BTN", self, self.updateStarRiverBtn);
	self:addLuaEvent("UPDATE_STARTRIAL_CHAPTER_SELECT", self, self.updateSelect);
	Lua_ProxyManager.getProxy("Lua_StarTrialProxy"):sStarTrialInfo(0);
end

function Lua_StarTrialLevelPanel:dispose()
	if self.stageItemArr ~= nil then
		self.stageItemArr:dispose();
		self.stageItemArr:clear();
		self.stageItemArr = nil;
	end
	if self.rewardBoxArr ~= nil then
		self.rewardBoxArr:dispose();
		self.rewardBoxArr:clear();
		self.rewardBoxArr = nil;
	end
	if self._boxEff ~= nil then
		self._boxEff:dispose();
		self._boxEff = nil;
	end
	if self.levelInfo ~= nil then
		self.levelInfo:dispose();
		self.levelInfo = nil;
	end
	if self.dragContainer ~= nil then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end
	if self.trialRedPoint ~= nil then
		self.trialRedPoint:dispose();
		self.trialRedPoint = nil;
	end
	self:superCall("dispose");
end

function Lua_StarTrialLevelPanel:updateSelect(data)
	Lua_ProxyManager.getProxy("Lua_StarTrialProxy"):sStarTrialInfo(data.chapter);
	self.selectLevel = data.level;
	self.selectChapter = data.chapter;
	self.isPlayTween = true;
end

function Lua_StarTrialLevelPanel:updatePanel()
	self:showLevel();
	self:showTips();
	self:updateStarReward();
	self:askStarRiverInfo();
end

function Lua_StarTrialLevelPanel:showLevel()
	if DataCenter.starTrialData.curChapter == nil or DataCenter.starTrialData.totalChapter == nil then
		return;
	end

	--只有打开界面时(即self.selectChapter = nil),和解锁新章节时才会自动切章节
	if self.selectChapter == nil or self.autoCutChapter == true then
		self.isPlayTween = true;
		self.selectChapter = DataCenter.starTrialData.curChapter;
	end

	local chapterVo = DataCenter.starTrialUitl:getChapterVo(self.selectChapter);
	local stageVoArr = chapterVo.stageVoArr;
	local stageLen = stageVoArr:getSize();
	if chapterVo == nil or chapterVo.stageVoArr == nil then
		return;
	end

    local nextChapter = self.selectChapter + 1;
    local maxChapter = #DataCenter.starTrialUitl.getChapterConfig;
	if nextChapter <= maxChapter then
		local nextChapterVo = DataCenter.starTrialUitl:getChapterVo(nextChapter);
		--满足条件1:通关本章节的所有关卡,条件2:本章节满足解锁下一章节条件,条件3:下一章节处于未解锁状态(3个条件综合即为解锁新章节的时候)
		if chapterVo.isPass and chapterVo.canOpenNextChapter and nextChapterVo.state ~= 1 then
			self.autoCutChapter = true;
		else
			self.autoCutChapter = false;
		end
	end

	if chapterVo.isUnlockNewStage then --如果解锁了新关卡那就重新定位关卡
		self.selectLevel = nil;
	end
 	if self.selectLevel == nil then
    	for i = 1, stageLen do
    		if chapterVo.isMaxStar == false then
    			if stageVoArr[i].state == 1 then --1.默认选中挑战中的
	    			self.selectLevel = i;
	    			break;
    		    end
    		    for i = 1, stageLen do
    		    	if stageVoArr[i].isMaxStar == false then --2.选中未满星的
	    			    self.selectLevel = stageVoArr[i].index;
	    			    break;
	    			end
    		    end
    		else
    			self.selectLevel = chapterVo.stageVoArr:getSize(); --3.选中最后一关
    		end
    	end
    end

    self.dragContainer:clearList();
    self.dragContainer:addSubContainer(Lua_StarTrialStarParentItem, chapterVo.stageVoArr, false);
    self.dragContainer:updateChildPos();
    self.dragContainer:setSubPosition(self.dragContainer.subMaxPox);
    if self.isPlayTween == true then
    	self.isPlayTween = false;
	    self.dragContainer.showList[1]:playTween();
	end
	self:onSubStartMove();
    self.dragContainer.showList[1]:setSelect(self.selectLevel);
end

function Lua_StarTrialLevelPanel:showTips()
	local chapterVo = DataCenter.starTrialUitl:getChapterVo(self.selectChapter);
	if chapterVo == nil or chapterVo.stageVoArr == nil then
		return;
	end

	local stageVoArr = chapterVo.stageVoArr;
	local stageLen = stageVoArr:getSize();
	local nextChapter = self.selectChapter + 1;
    local chapterCount = DataCenter.starTrialUitl.getChapterArr:getSize();
    if nextChapter <= chapterCount then
    	local nextChapterVo = DataCenter.starTrialUitl:getChapterVo(nextChapter);
		if chapterVo.isPass and (chapterVo.starNum < nextChapterVo.unlock_star or DataCenter.roleData.level < nextChapterVo.limit_lvl) then
    		self.tipsBg:setEnable(true);
	    	self.tipsTxt:setEnable(true);
	    	self.collectStarTxt:setEnable(true);
	    	self.roleLevelTxt:setEnable(true);
	    	self.collectNumTxt:setEnable(true);
	    	self.levelNumTxt:setEnable(true);
    		self.collectNumTxt.text = chapterVo.starNum.."/"..nextChapterVo.unlock_star;
    		self.levelNumTxt.text = nextChapterVo.limit_lvl;
    		if chapterVo.starNum < nextChapterVo.unlock_star then
    			self.collectNumTxt.colorStr = Lua_ColorDefine.transColorStr("E55757");
    		else
    			self.collectNumTxt.colorStr = Lua_ColorDefine.transColorStr("2CE654");
    		end
    		if DataCenter.roleData.level < nextChapterVo.limit_lvl then
    			self.levelNumTxt.colorStr = Lua_ColorDefine.transColorStr("E55757");
    		else
    			self.levelNumTxt.colorStr = Lua_ColorDefine.transColorStr("2CE654");
    		end
	    else
	    	self.tipsBg:setEnable(false);
	    	self.tipsTxt:setEnable(false);
	    	self.collectStarTxt:setEnable(false);
	    	self.roleLevelTxt:setEnable(false);
	    	self.collectNumTxt:setEnable(false);
	    	self.levelNumTxt:setEnable(false);
	    end
	else
		self.tipsBg:setEnable(false);
    	self.tipsTxt:setEnable(false);
    	self.collectStarTxt:setEnable(false);
    	self.roleLevelTxt:setEnable(false);
    	self.collectNumTxt:setEnable(false);
    	self.levelNumTxt:setEnable(false);
    end
end

function Lua_StarTrialLevelPanel:askStarRiverInfo()
	if DataCenter.funcOpenData:isOpened(DataCenter.starRiverTrialData.config["const"].act_open_id) then
		Lua_ProxyManager.getProxy("Lua_LimitedTimeActivityProxy"):sStarRiverTrialInfo(0);
	end
end

function Lua_StarTrialLevelPanel:updateStarRiverBtn(state)
 	if self.trialRedPoint == nil then
 		return;
 	end
	self.trialRedPoint:updateRedPointShow(state);
end

function Lua_StarTrialLevelPanel:updateStarReward()
	local chapterVo = DataCenter.starTrialUitl:getChapterVo(self.selectChapter);
	self.starNumTxt.text = LanUtil.formateStr(201622, chapterVo.starNum, chapterVo.total_star);
	self.starBar:setMaxValue(chapterVo.total_star);
	self.starBar:setValue(chapterVo.starNum);

	local itemNum = self.rewardBoxArr:getSize();
	local voNum = chapterVo.starRewardList == nil and 0 or #chapterVo.starRewardList;
	local showNum = itemNum > voNum and itemNum or voNum;
	local item;
	for i = 1, showNum do
		if i > itemNum then
			item = Lua_StarTrialRewardItem.new(self.content);
			self.rewardBoxArr:add(item);
		else
			item = self.rewardBoxArr[i];
		end

		if i <= voNum then
			local ratio = chapterVo.starRewardList[i].star_cond / chapterVo.total_star;
			item:setLocation(-309, 353 + 310 * ratio, 0);
			item:setData(chapterVo.starRewardList[i], i);
			item:setRectAnchor(7);
			item:setEnable(true);
		else
			item:setEnable(false);
		end
	end
end

function Lua_StarTrialLevelPanel:updateDailyReward()
	self:setEffectShow(tonumber(DataCenter.starTrialData.sweepTimes) ~= 0);
	self.sweepNumTxt.text = DataCenter.starTrialData.sweepTimes.."/"..DataCenter.starTrialUitl:getConstConfig("daily_times", "value");
end

function Lua_StarTrialLevelPanel:setEffectShow(val)
	if val then
		if self._boxEff == nil then
			self._boxEff = Lua_RedPointIcon.new(self.content);
			self._boxEff:setLocation(312, 313, 0);
			self._boxEff:setRectAnchor(7);
			self._boxEff:createRedPointEff();
			self._boxEff:updateRedPointShow(true);
		end
		self._boxEff:setEnable(true);
	else
		if self._boxEff ~= nil then
			self._boxEff:setEnable(false);
		end
	end
end

function Lua_StarTrialLevelPanel:buildLevelInfo(data)
    if self.levelInfo == nil then
	    self.levelInfo = Lua_StarTrialLevelInfoItem.new(self.content);
	    self.levelInfo:setRectAnchor(7);
		self.levelInfo:setLocation(0, 163);
    end
    self.selectLevel = data.index;--当前选中的关卡
	self.levelInfo:setData(data);
end

function Lua_StarTrialLevelPanel:onSubStartMove(isGradually)
	local stageArr = DataCenter.starTrialUitl:getChapterVo(self.selectChapter).stageVoArr;
	if stageArr == nil then
		return;
	end
    
    local pos = -stageArr[self.selectLevel].stage_pos[2];
    if pos > self.dragContainer.subMaxPox then
    	pos = self.dragContainer.subMaxPox;
    elseif pos < self.dragContainer.subMinPos then
    	pos = self.dragContainer.subMinPos;
    end
	self.dragContainer.moveTime = DataCenter.starTrialUitl.stageMoveTime;
	self.dragContainer:moveToTargetPos(pos);
end

function Lua_StarTrialLevelPanel:closeTrialBtn()
	if self.trialBtn ~= nil then
		self.trialBtn:setEnable(false);
    end
end

function Lua_StarTrialLevelPanel:onStarRiverTrialClick(go)
	DataCenter.funcPathUtil:gotoFunction(DataCenter.starRiverTrialData.config["const"].event_trial_id, true)
end

function Lua_StarTrialLevelPanel:onTipIconClick()
	local tipsData = { des = LanUtil.getValue(201602), posX = 181, posY = -237 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_StarTrialLevelPanel:onViewBtnClick()
	Lua_WindowUtil.openWin("Lua_StarTrialChapterViewWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_StarTrialLevelPanel:onBoxIconClick()
	Lua_WindowUtil.openWin("Lua_StarTrialDailyRewardWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_StarTrialLevelPanel:onRankBtnClick()
	DataCenter.funcPathUtil:gotoFunction(1084)
end

function Lua_StarTrialLevelPanel:onScreenResize(adaptHeight)
    self:superCall("onScreenResize", adaptHeight);

    self.dragContainer:setContentRect(720, 850 + adaptHeight);
    self.maskBg:setLocation(0, 360 - adaptHeight);
end























Lua_StarTrialRewardItem = class("Lua_StarTrialRewardItem", Lua_DisplayObject);

function Lua_StarTrialRewardItem:ctor(p)
	self:superCall("ctor", p, "StarTrialRewardItem_skin");
end

function Lua_StarTrialRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.boxIcon:addClickFuntion(self, self.onBoxIconClick);
end

function Lua_StarTrialRewardItem:dispose()
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self.boxEffect = nil;
	self.data = nil;
	self:superCall("dispose");
end

function Lua_StarTrialRewardItem:setData(data, index)
	self.data = data;
	self.showTxt.text = data.star_cond;

	if data.state == 0 then
		self.boxIcon:setAltas("common_altas_4", "ui_djc_box_00"..index.."_n");
		self.boxIcon.alpha = 1;
		if self.boxEffect ~= nil then
			self.boxEffect:setEnable(false);
		end
	elseif data.state == 1 then
		self.boxIcon:setAltas("common_altas_4", "ui_djc_box_00"..index.."_n");
		if self.boxEffect == nil then
			self.boxEffect = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_ty_xbx_0101_"..index, "ui_ty_xbx_0101_"..index, 0, 0);
			self.boxEffect.siblingIndex = 0;
		else
			self.boxEffect:setUrl("/effects/uiEffects/ui_ty_xbx_0101_"..index, "ui_ty_xbx_0101_"..index);
		end
		self.boxIcon.alpha = 0.01;
		self.boxEffect:setEnable(true);

		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:createRedPointEff();
			self.redPoint:setLocation(25, 15);
		end
	elseif data.state == 2 then
		self.boxIcon:setAltas("common_altas_4", "ui_djc_box_00"..index.."_p");
		self.boxIcon.alpha = 1;
		if self.boxEffect ~= nil then
			self.boxEffect:setEnable(false);
		end
	end

	if self.redPoint ~= nil then
		self.redPoint:updateRedPointShow(data.state == 1);
	end
end

function Lua_StarTrialRewardItem:onBoxIconClick()
	if self.data.state == 1 then
		self.boxEffect:setUrl("/effects/uiEffects/ui_ty_xbx_0101_6", "ui_ty_xbx_0101_6");
		Lua_ProxyManager.getProxy("Lua_StarTrialProxy"):sGetStarReward(self.data.chapter, self.data.id);
	else
		Lua_WindowUtil.openWin("Lua_StarTrialStarRewardWindow", Lua_WinParam.ACTION_OPEN, self.data.chapter);
	end
end







Lua_StarTrialStarParentItem = class("Lua_StarTrialStarParentItem", Lua_DragContainerItem)
function Lua_StarTrialStarParentItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_StarTrialStarParentItem:buildShowItem()
	self:superCall("buildShowItem");
	self.stageItemArr = Array();

	self:addLuaEvent("STARTRIAL_SELECT_LEVEL", self, self.showSelectIcon);
end

function Lua_StarTrialStarParentItem:setData(data)
	self._data = data;
	local len = self.stageItemArr:getSize();
	local dataLen = data == nil and 0 or data:getSize();
	local maxLen = dataLen > len and dataLen or len;
	local item;
  
	local curStagePos;
	local nextStagePos;
	local intervalX;
	local intervalY;
	local interval;
	local angle;

	self.minStagePosY = data[1].stage_pos[2];
	self.maxStagePosY = data[dataLen].stage_pos[2];

	for i = 1, maxLen do
		item = self.stageItemArr[i];
		if i > dataLen then
			if item ~= nil then
				item:setEnable(false);
			end
		else
			if data[i].stage_pos[2] < self.minStagePosY then
				self.minStagePosY = data[i].stage_pos[2];
			end
			if data[i].stage_pos[2] > self.maxStagePosY then
				self.maxStagePosY = data[i].stage_pos[2];
			end

			if item == nil then
				item = Lua_StarTrialStageItem.new(self.content);
				self.stageItemArr:add(item);
			end
			item:setSiblingIndex(1);
			item:setData(data[i]);

			if data[i + 1] ~= nil then
				curStagePos = data[i].stage_pos;
				nextStagePos = data[i + 1].stage_pos;
				intervalX = nextStagePos[1] - curStagePos[1];
				intervalY = nextStagePos[2] - curStagePos[2];
				interval = (intervalX ^ 2 + intervalY ^ 2) ^ 0.5;
				angle = Mathf.Rad2Deg * (Mathf.Acos(intervalX/interval));
				item.line:SetDimensions(interval, 15);
				item.line:setRot(0, 0, angle)
			else
				item.line:setEnable(false);
			end
		end
	end
end

function Lua_StarTrialStarParentItem:playTween()
	local lineTime = DataCenter.starTrialUitl.lineTime;
	self.thingIndex = 1;
	for i = 1, self._data:getSize() do
		self.stageItemArr[i]:setEnable(false);
	end
	if self.bTimer ~= true then
		self.bTimer = true;
		self:addTimer("onShowLevel", lineTime, self, self.onShowLevel);
	end
end

function Lua_StarTrialStarParentItem:onShowLevel()
	if self.thingIndex >= 2 * self._data:getSize() - 1 then
		if self.bTimer == true then
			self.bTimer = false;
			Lua_CommonUtil.removeTimer(self, self.onShowLevel);
		end
	end
	
	local levelIndex = Mathf.Ceil(self.thingIndex / 2)
	if self.thingIndex % 2 ~= 0 then
	 	self.stageItemArr[levelIndex]:setEnable(true);
    else
		self.stageItemArr[levelIndex].line:setEnable(true);
    end
    self.thingIndex = self.thingIndex + 1;
end

function Lua_StarTrialStarParentItem:setSelect(index)
	self.stageItemArr[index]:onBgClick();
end

function Lua_StarTrialStarParentItem:showSelectIcon(data)
	for i = 1, self.stageItemArr:getSize() do
		self.stageItemArr[i].selectIcon:setEnable(false);
	end
	self.stageItemArr[data.index].selectIcon:setEnable(true);
end

function Lua_StarTrialStarParentItem:getWidth()
	return 720;
end

function Lua_StarTrialStarParentItem:getHeight()
	local len = self._data:getSize();
	local height = self.maxStagePosY - self.minStagePosY + 700;
	return height;
end

function Lua_StarTrialStarParentItem:dispose()
	if self.stageItemArr ~= nil then
		self.stageItemArr:dispose();
		self.stageItemArr:clear();
		self.stageItemArr = nil;
	end
	if self._data ~= nil then
		self._data:dispose();
		self._data:clear();
		self._data = nil;
	end

	if self.bTimer == true then
		self.bTimer = false;
		Lua_CommonUtil.removeTimer(self, self.onShowLevel);
	end

	self:superCall("dispose");
end


















Lua_StarTrialStageItem = class("Lua_StarTrialStageItem", Lua_DragContainerItem);

function Lua_StarTrialStageItem:ctor(p)
	self:superCall("ctor", p, "StarTrialStageItem_skin");
end

function Lua_StarTrialStageItem:buildShowItem()
	self:superCall("buildShowItem");
    
    self.selectIcon:setEnable(false);
	self.starArr = Array();
	local starIcon;
	for i = 1, 3 do
		starIcon = UICreate.createUIAtlasImage(self.content, "", "", 0, 0, 36, 35);
		starIcon:setLocation(-33 + (i -1) * 36, -94, 0);
		self.starArr:add(starIcon);
	end

	self.bg:addClickFuntion(self, self.onBgClick);
end

function Lua_StarTrialStageItem:dispose()
	if self.starArr ~= nil then
		self.starArr:dispose();
		self.starArr:clear();
		self.starArr = nil;
	end
	
	self:superCall("dispose");
end

function Lua_StarTrialStageItem:setData(data)
	self.data = data;

	self.showTxt.text = data.chapter .."-" ..data.index;
	local num = 0;
	for i = 1, 3 do
		if data.starDic[i] == false then
			num = num + 1;
		end
	end
	for i = 1, 3 do
		if i <= num then
			self.starArr[i]:setAltas("starTrial_altas", "xui_xhd_label_002");
		else
			self.starArr[i]:setAltas("starTrial_altas", "xui_xhd_label_010");
		end
		self.starArr[i]:setScale(0.86, 0.86);
	end

	if tonumber(data.iconType) % 2 == 0 then
		self.bg:setAltas("starTrial_altas", "xui_xhd_widget_013");
		self.bg:SetDimensions(213, 169);
		self.selectIcon:setScale(1, 1);
		self.selectIcon:setLocation(0, 0);
	else
		self.bg:setAltas("starTrial_altas", "xui_xhd_widget_014");
		self.bg:SetDimensions(132, 108);
		self.selectIcon:setScale(0.68, 0.68);
		self.selectIcon:setLocation(4, -5);
	end

    if data.stage_pos ~= nil then
		self:setLocation(data.stage_pos[1], data.stage_pos[2], 0);
    end
	self:setEffectShow(data.state == 1);
end

function Lua_StarTrialStageItem:setEffectShow(val)
	if val then
		if self._threatEff == nil then
			self._threatEff = UICreate.createUIAtlasImage(self.content, "starTrial_altas", "xui_xhd_tab_02", 30, 39, 55, 54);
		end
		self._threatEff:setEnable(true);
	else
		if self._threatEff ~= nil then
			self._threatEff:setEnable(false);
		end
	end
end

function Lua_StarTrialStageItem:onBgClick()
	if self.data.limit_lvl > DataCenter.roleData.level then
		OperateAlert.show(LanUtil.formateStr(201618, tostring(self.data.limit_lvl)));
		return;
	end
    Lua_MsgUtil.callFunc("STARTRIAL_SELECT_LEVEL", self.data);
end